# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import fields,osv
from tools.translate import _
    
class mrp_workcenter(osv.osv):   
     _description = 'Work Center Inheritance'
     _inherit = 'mrp.workcenter'
     
     _columns = {
                'location_id': fields.many2one('stock.location', 'Location', required= True, domain=[('usage','in',('internal','supplier'))]),
                'purchase_date': fields.date('Purchase Date', size = 32, help = "The machine's purchase date"),
                'warranty_date': fields.date('Warranty Date', size = 32, help = "Warranty limit date of the Work Center"),
                'maintain_notes': fields.text('Maintain Notes', readonly = False),
                'alter_workcenter_ids': fields.many2many('mrp.workcenter','alter_workcenter','parent_workcenter_id','child_workcenter_id','Alternative Work center'),
                'mrp_op_ids': fields.many2many('mrp.operation', 'mrp_operations_workcenter', 'workcenter_id', 'operation_id','Operations', domain=[('type','=','mfo')]),
                'maintain_op_id': fields.many2one('mrp.operation', 'Maintain Operation', size = 32, domain=[('type','=','mto')]),
                'factory_id': fields.many2one('mrp.factory', 'Factory', required= True),
                'operations_product_ids': fields.one2many('mrp.bom.operations.product', 'workcenter_id', 'Work Center', required= True),
                'user_ids': fields.many2many('res.users', 'mrp_wc_user_rel', 'workcenter_id', 'user_id'),
            }
     
     def cycle_onchange(self, cr, uid, ids, time_cycle, costs_hour):
        value = {}
        costh = costs_hour * time_cycle
        value['costs_cycle'] = costh
        return {'value':value}
     
     def default_get(self, cr, uid, fields_list, context=None):

        if context == None:

            context = {}

        res = super(mrp_workcenter, self).default_get(cr, uid, fields_list, context)

        if 'factory' in context.keys():

            if context['factory']:

                ids = self.pool.get('mrp.factory').search(cr, uid, [('name', '=', context['factory'])])

                res.update({'factory_id': ids[0]})
 
        return res
     
     
mrp_workcenter()